--------------------------------------------------------------------------------
--"CopyMaxFileName"
--"produced by apras();"
--"http://www.apras.net/"
--
--memo
--JĂMaxt@CNbv{[hɃRs[}NXNvgł
--
--------------------------------------------------------------------------------
macroScript CopyMaxFileName category:"apras" tooltip:"CopyMaxFileName"
(
	local _openFileName = maxFileName
	_openFileName = getFilenameFile _openFileName
	setclipboardText _openFileName
)


--------------------------------------------------------------------------------
--"GeneMaxFileName"
--"produced by apras();"
--"http://www.apras.net/"
--
--memo
--MaxFileNamer.iniɋLqĂtH[}bgɏ]ăt@C𐶐A
--Nbv{[hɃRs[}NXNvgł
--t̏́A"http://dobon.net/vb/dotnet/string/datetimeformat.html" Ql
--ʂԍ́A"http://dobon.net/vb/dotnet/string/inttostring.html" Ql
--------------------------------------------------------------------------------
macroScript GeneMaxFileName category:"apras" tooltip:"GeneMaxFileName"
(
	local _iniPath = (symbolicPaths.getPathValue 15) + "\\MaxFileNamer.ini"
	local _openFileName = maxFileName
	
	local _format = getINISetting _iniPath "GeneMaxFileName" "Format"
	
	if (_format == "") then
	(
		_format = "yyMMdd_xx"
		if  ( not (setINISetting _iniPath "GeneMaxFileName" "Format" _format) ) then
		(
			messageBox "Failed to create INI files."
			_format == ""
		)
	)
	
	if ( (_openFileName == "") and (_format != "") )then
	(
		-- Text Box
		local _tb_Filename = dotNetObject "System.Windows.Forms.TextBox"
		_tb_Filename.size = dotNetObject "System.Drawing.Size" 300 20
		_tb_Filename.location = dotNetObject "System.Drawing.Point" 7 5
		
		-- Button 
		local _button_OK = dotNetObject "System.Windows.Forms.Button"
		_button_OK.text = "OK"
		_button_OK.size = dotNetObject "System.Drawing.Size" 300 20
		_button_OK.location = dotNetObject "System.Drawing.Point" 7 25

		-- Form
		local _form_dialog = dotNetObject "System.Windows.Forms.Form"
		_form_dialog.Text = "Base Name"
		_form_dialog.size = dotNetObject "System.Drawing.Size" 320 75
		
		_form_dialog.controls.add _tb_Filename
		_form_dialog.controls.add _button_OK
		
		_form_dialog.topmost = true
		_form_dialog.FormBorderStyle = (dotNetClass "System.Windows.Forms.FormBorderStyle").FixedToolWindow

		-- Event
		dotNet.addEventHandler _button_OK "click" (fn _close = (_openFileName = _tb_Filename.Text;  /*if (_openFileName != "") then*/ _form_dialog.close() ))
			
		-- Show Form
		_form_dialog.showDialog()
	)
	
	if ( (_openFileName != "") and (_format != "") ) then
	(
		_openFileName = getFilenameFile _openFileName
		
		local _date = getLocalTime()
		local _date = (dotNetClass "System.DateTime").Now
		
		-- Count
		local _count = 1

		local _coutStartIndex = 100000
		local _coutEndIndex = 100000
		_coutStartIndex = findString _format "0"
		for _i = (_coutStartIndex + 1) to _format.count do
		(
			if (_format[_i] != "0") then
			(
				_coutEndIndex = _i - 1
				break;
			)
		)
		if ( (_coutStartIndex != 100000) and ( _coutEndIndex == 100000 ) ) then
			_coutEndIndex = _format.count
		
		if (_openFileName.count > _coutStartIndex) then
		(
			_count = substring _openFileName ((_openFileName.count - _format.count) + _coutStartIndex) (_coutEndIndex - _coutStartIndex + 1)
			_count = _count as Integer
			_count = _count + 1
		)
		
		-- BaseName
		local _baseName = substring _openFileName 1 (_openFileName.count - _format.count)
				
		
		local _intCount = dotNetObject "System.Int32" _count
		_format = _intCount.ToString(_format)

		_openFileName = _baseName
		_openFileName = _openFileName + _date.ToString(_format)
			
		setclipboardText _openFileName
	)
)